__global__ void cuda_calnum(int* bucket_size_d, int* key_array_d, int shift, int NUM_KEYS)
{
		int idx = blockIdx.x * blockDim.x + threadIdx.x;
		if(idx < NUM_KEYS)
		{
				int buck = key_array_d[idx] >> shift;
				atomicAdd(bucket_size_d + buck, 1);
		}
		__syncthreads();
}


__global__ void cuda_sort(int* key_buff1_d, int* key_array_d, int* bucket_ptrs_d, int shift, int NUM_KEYS)
{
		int idx = blockIdx.x * blockDim.x + threadIdx.x;

		if(idx < NUM_KEYS)
		{
				int key = key_array_d[idx];				
				int pos = key >> shift;
				int cur = atomicAdd(bucket_ptrs_d + pos, 1);
				key_buff1_d[cur] = key;
		}
		__syncthreads();
}

__global__ void cuda_indi_rank(int* key_buff1_d, int* key_buff2_d, int j, int min_key_val)
{
		int idx = blockIdx.x * blockDim.x + threadIdx.x;
		if(idx < j)
		{
				int pos = key_buff2_d[idx] - min_key_val;
				atomicAdd(key_buff1_d + pos, 1);
		}
		__syncthreads();
}
